SoFaceDetail Class Reference

| http://www.sim.no/ http://www.coin3d.org/

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | List of all members
SoFaceDetail Class Reference
Detail Classes

The SoFaceDetail class is for storing detailed polygon information.Instances of this class are used among other things for storing information about polygons after pick operations, and for storing information returned to tessellation callbacks. More...

`#include <Inventor/details/SoFaceDetail.h>`

Inheritance diagram for SoFaceDetail:

## Public Member Functions
virtual SoType | getTypeId (void) const
| SoFaceDetail (void)
virtual | ~SoFaceDetail ()
virtual SoDetail * | copy (void) const
int | getNumPoints (void) const
const SoPointDetail * | getPoint (const int idx) const
SoPointDetail * | getPoints (void)
int | getFaceIndex (void) const
int | getPartIndex (void) const
void | setNumPoints (const int num)
void | setPoint (const int idx, const SoPointDetail *const detail)
void | setFaceIndex (const int idx)
void | setPartIndex (const int idx)
void | incFaceIndex (void)
void | incPartIndex (void)
Public Member Functions inherited from SoDetail
virtual | ~SoDetail ()
SbBool | isOfType (const SoType type) const

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | cleanupClass (void)
static void | initClass (void)
Static Public Member Functions inherited from SoDetail
static void | initClass (void)
static void | initClasses (void)
static SoType | getClassTypeId (void)

## Additional Inherited Members
Protected Member Functions inherited from SoDetail
| SoDetail (void)

## Detailed Description

The SoFaceDetail class is for storing detailed polygon information.

Instances of this class are used among other things for storing information about polygons after pick operations, and for storing information returned to tessellation callbacks.

Note that a SoFaceDetail instance consists of a set of SoPointDetail instances, one for each vertex of the polygon it represents.

See also
  SoRayPickAction, SoPickedPoint, SoCallbackAction

## Constructor & Destructor Documentation

SoFaceDetail::SoFaceDetail | ( | void |  | ) |

Default constructor sets up an empty, non-valid detail specification.

SoFaceDetail::~SoFaceDetail | ( |  | ) |
| virtual

Destructor, free internal resources used for storing the polygon vertices.

## Member Function Documentation

SoType SoFaceDetail::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of a detail derived from a class inheriting SoDetail. This is used for run-time type checking and "downward" casting.

Usage example:

void fuhbear(SoDetail * detail)
{
if (detail->getTypeId() == SoFaceDetail::getClassTypeId()) {
// safe downward cast, know the type
SoFaceDetail * facedetail = (SoFaceDetail *)detail;
}
return; // ignore if not a SoFaceDetail
}

For application programmers wanting to extend the library with new detail classes: this method needs to be overridden in all subclasses. This is typically done as part of setting up the full type system for extension classes, which is usually accomplished by using the pre-defined macros available through Inventor/nodes/SoSubDetail.h: SO_DETAIL_SOURCE and SO_DETAIL_INIT_CLASS.

Implements SoDetail.

SoDetail * SoFaceDetail::copy | ( | void |  | ) | const
| virtual

Return a deep copy of ourself.

Note that if the Coin library has been built as a DLL under Microsoft Windows and you use this method from application code, you must make sure that both the Coin DLL and the application executable is using the same instance of a C Run-Time (CRT) library. Otherwise, you will get memory heap corruption upon deallocating the returned instances, eventually leading to mysterious crashes.

Implements SoDetail.

int SoFaceDetail::getNumPoints | ( | void |  | ) | const

Number of vertices making up the polygon.

const SoPointDetail * SoFaceDetail::getPoint | ( | const int | idx | ) | const

Returns a pointer into the array of vertices, starting at the idx'th vertice of the polygon.

The array will contain (SoFaceDetail::getNumPoints() - idx) elements.

SoPointDetail * SoFaceDetail::getPoints | ( | void |  | ) |

Returns the full array of vertice details for the polygon. The array will contain SoFaceDetail::getNumPoints() elements.

int SoFaceDetail::getFaceIndex | ( | void |  | ) | const

Returns the index of this polygon within the faceset node it is part of.

int SoFaceDetail::getPartIndex | ( | void |  | ) | const

If this SoFaceDetail represents a triangle tessellated from a complex shape, this method returns the index of the part of the complex shape it was tessellated from.

void SoFaceDetail::setNumPoints | ( | const int | num | ) |

Used internally from library client code setting up a SoFaceDetail instance.

See also
  getNumPoints()

void SoFaceDetail::setPoint | ( | const int | idx,
|  | const SoPointDetail *const | detail
| ) |  |

Used internally from library client code setting up a SoFaceDetail instance.

See also
  getPoint(), getPoints()

void SoFaceDetail::setFaceIndex | ( | const int | idx | ) |

Used internally from library client code setting up a SoFaceDetail instance.

See also
  getFaceIndex()

void SoFaceDetail::setPartIndex | ( | const int | idx | ) |

Used internally from library client code setting up a SoFaceDetail instance.

See also
  getPartIndex()

void SoFaceDetail::incFaceIndex | ( | void |  | ) |

Used internally from library client code setting up a SoFaceDetail instance.

This function is specific for Coin, and is not present in SGI/TGS Open Inventor.

void SoFaceDetail::incPartIndex | ( | void |  | ) |

Used internally from library client code setting up a SoFaceDetail instance.

This function is specific for Coin, and is not present in SGI/TGS Open Inventor.

The documentation for this class was generated from the following files:

- SoFaceDetail.h
- SoFaceDetail.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.